diff --git a/libavcodec/aac_adtstoasc_bsf.c b/libavcodec/aac_adtstoasc_bsf.c
index e378296950..1d0117fecb 100644
--- a/libavcodec/aac_adtstoasc_bsf.c
+++ b/libavcodec/aac_adtstoasc_bsf.c
@@ -22,7 +22,7 @@
 #include "adts_header.h"
 #include "adts_parser.h"
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "put_bits.h"
 #include "get_bits.h"
 #include "mpeg4audio.h"
diff --git a/libavcodec/av1_frame_merge_bsf.c b/libavcodec/av1_frame_merge_bsf.c
index 49397111fc..c67b86c8d4 100644
--- a/libavcodec/av1_frame_merge_bsf.c
+++ b/libavcodec/av1_frame_merge_bsf.c
@@ -19,7 +19,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_av1.h"
 
diff --git a/libavcodec/av1_frame_split_bsf.c b/libavcodec/av1_frame_split_bsf.c
index a386c6edc1..fc9eac0324 100644
--- a/libavcodec/av1_frame_split_bsf.c
+++ b/libavcodec/av1_frame_split_bsf.c
@@ -33,7 +33,7 @@
 #include "libavutil/avassert.h"
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_av1.h"
 
diff --git a/libavcodec/av1_metadata_bsf.c b/libavcodec/av1_metadata_bsf.c
index dd0c9b6148..d704bc1409 100644
--- a/libavcodec/av1_metadata_bsf.c
+++ b/libavcodec/av1_metadata_bsf.c
@@ -19,7 +19,7 @@
 #include "libavutil/common.h"
 #include "libavutil/opt.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_av1.h"
 
diff --git a/libavcodec/bitstream_filters.c b/libavcodec/bitstream_filters.c
index 6b5ffe4d70..8a1005ac56 100644
--- a/libavcodec/bitstream_filters.c
+++ b/libavcodec/bitstream_filters.c
@@ -22,7 +22,7 @@
 #include "libavutil/log.h"
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 extern const AVBitStreamFilter ff_aac_adtstoasc_bsf;
 extern const AVBitStreamFilter ff_av1_frame_merge_bsf;
diff --git a/libavcodec/bsf.c b/libavcodec/bsf.c
index 7b96183e64..a8d5c3082a 100644
--- a/libavcodec/bsf.c
+++ b/libavcodec/bsf.c
@@ -25,7 +25,7 @@
 #include "libavutil/bprint.h"
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 struct AVBSFInternal {
     AVPacket *buffer_pkt;
diff --git a/libavcodec/bsf.h b/libavcodec/bsf_internal.h
similarity index 93%
rename from libavcodec/bsf.h
rename to libavcodec/bsf_internal.h
index af035eee44..de4684c4c2 100644
--- a/libavcodec/bsf.h
+++ b/libavcodec/bsf_internal.h
@@ -16,8 +16,8 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#ifndef AVCODEC_BSF_H
-#define AVCODEC_BSF_H
+#ifndef AVCODEC_BSF_INTERNAL_H
+#define AVCODEC_BSF_INTERNAL_H
 
 #include "avcodec.h"
 
@@ -41,4 +41,4 @@ int ff_bsf_get_packet_ref(AVBSFContext *ctx, AVPacket *pkt);
 
 const AVClass *ff_bsf_child_class_next(const AVClass *prev);
 
-#endif /* AVCODEC_BSF_H */
+#endif /* AVCODEC_BSF_INTERNAL_H */
diff --git a/libavcodec/chomp_bsf.c b/libavcodec/chomp_bsf.c
index 3ba45f3e06..d7461afebd 100644
--- a/libavcodec/chomp_bsf.c
+++ b/libavcodec/chomp_bsf.c
@@ -20,7 +20,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "internal.h"
 
 static int chomp_filter(AVBSFContext *ctx, AVPacket *pkt)
diff --git a/libavcodec/dca_core_bsf.c b/libavcodec/dca_core_bsf.c
index 8565796951..b78995dbb7 100644
--- a/libavcodec/dca_core_bsf.c
+++ b/libavcodec/dca_core_bsf.c
@@ -19,7 +19,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 #include "dca_syncwords.h"
 #include "libavutil/mem.h"
diff --git a/libavcodec/dump_extradata_bsf.c b/libavcodec/dump_extradata_bsf.c
index 0b6d404792..9727b9983a 100644
--- a/libavcodec/dump_extradata_bsf.c
+++ b/libavcodec/dump_extradata_bsf.c
@@ -21,7 +21,7 @@
 #include <string.h>
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 #include "libavutil/log.h"
 #include "libavutil/mem.h"
diff --git a/libavcodec/eac3_core_bsf.c b/libavcodec/eac3_core_bsf.c
index 3e4dc2e2a2..c584d69227 100644
--- a/libavcodec/eac3_core_bsf.c
+++ b/libavcodec/eac3_core_bsf.c
@@ -19,7 +19,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "get_bits.h"
 #include "ac3_parser_internal.h"
 
diff --git a/libavcodec/extract_extradata_bsf.c b/libavcodec/extract_extradata_bsf.c
index 46b76dfbef..d7ffa1bff2 100644
--- a/libavcodec/extract_extradata_bsf.c
+++ b/libavcodec/extract_extradata_bsf.c
@@ -26,7 +26,7 @@
 #include "avcodec.h"
 #include "av1.h"
 #include "av1_parse.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 #include "h2645_parse.h"
 #include "h264.h"
diff --git a/libavcodec/filter_units_bsf.c b/libavcodec/filter_units_bsf.c
index 380f23e5a7..7c3819c7b3 100644
--- a/libavcodec/filter_units_bsf.c
+++ b/libavcodec/filter_units_bsf.c
@@ -21,7 +21,7 @@
 #include "libavutil/common.h"
 #include "libavutil/opt.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 
 
diff --git a/libavcodec/h264_metadata_bsf.c b/libavcodec/h264_metadata_bsf.c
index d96a50dbf7..4cce5b1f1a 100644
--- a/libavcodec/h264_metadata_bsf.c
+++ b/libavcodec/h264_metadata_bsf.c
@@ -21,7 +21,7 @@
 #include "libavutil/common.h"
 #include "libavutil/opt.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_h264.h"
 #include "h264.h"
diff --git a/libavcodec/h264_mp4toannexb_bsf.c b/libavcodec/h264_mp4toannexb_bsf.c
index 0150f97a1a..52fc9b90cf 100644
--- a/libavcodec/h264_mp4toannexb_bsf.c
+++ b/libavcodec/h264_mp4toannexb_bsf.c
@@ -26,7 +26,7 @@
 #include "libavutil/mem.h"
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 #include "h264.h"
 
diff --git a/libavcodec/h264_redundant_pps_bsf.c b/libavcodec/h264_redundant_pps_bsf.c
index 8405738c4b..34885d320a 100644
--- a/libavcodec/h264_redundant_pps_bsf.c
+++ b/libavcodec/h264_redundant_pps_bsf.c
@@ -21,7 +21,7 @@
 #include "libavutil/common.h"
 #include "libavutil/mem.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_h264.h"
 #include "h264.h"
diff --git a/libavcodec/h265_metadata_bsf.c b/libavcodec/h265_metadata_bsf.c
index 730f7ac28f..6269ca00ab 100644
--- a/libavcodec/h265_metadata_bsf.c
+++ b/libavcodec/h265_metadata_bsf.c
@@ -19,7 +19,7 @@
 #include "libavutil/common.h"
 #include "libavutil/opt.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_h265.h"
 #include "hevc.h"
diff --git a/libavcodec/hapqa_extract_bsf.c b/libavcodec/hapqa_extract_bsf.c
index 5c22184813..9fdcbe2886 100644
--- a/libavcodec/hapqa_extract_bsf.c
+++ b/libavcodec/hapqa_extract_bsf.c
@@ -26,7 +26,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 #include "hap.h"
 
diff --git a/libavcodec/hevc_mp4toannexb_bsf.c b/libavcodec/hevc_mp4toannexb_bsf.c
index baa93628ed..f3efc33ab8 100644
--- a/libavcodec/hevc_mp4toannexb_bsf.c
+++ b/libavcodec/hevc_mp4toannexb_bsf.c
@@ -25,7 +25,7 @@
 #include "libavutil/mem.h"
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 #include "hevc.h"
 
diff --git a/libavcodec/imx_dump_header_bsf.c b/libavcodec/imx_dump_header_bsf.c
index 9a9de05f05..6f3d7e52b0 100644
--- a/libavcodec/imx_dump_header_bsf.c
+++ b/libavcodec/imx_dump_header_bsf.c
@@ -26,7 +26,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 
 
diff --git a/libavcodec/mjpeg2jpeg_bsf.c b/libavcodec/mjpeg2jpeg_bsf.c
index 6f02bc033c..25f5b31a73 100644
--- a/libavcodec/mjpeg2jpeg_bsf.c
+++ b/libavcodec/mjpeg2jpeg_bsf.c
@@ -31,7 +31,7 @@
 #include "libavutil/intreadwrite.h"
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "jpegtables.h"
 #include "mjpeg.h"
 
diff --git a/libavcodec/mjpega_dump_header_bsf.c b/libavcodec/mjpega_dump_header_bsf.c
index ca5fb3a377..e8a440a69f 100644
--- a/libavcodec/mjpega_dump_header_bsf.c
+++ b/libavcodec/mjpega_dump_header_bsf.c
@@ -26,7 +26,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 #include "mjpeg.h"
 
diff --git a/libavcodec/movsub_bsf.c b/libavcodec/movsub_bsf.c
index cd48aa7bb8..bfc06a70f8 100644
--- a/libavcodec/movsub_bsf.c
+++ b/libavcodec/movsub_bsf.c
@@ -21,7 +21,7 @@
 #include "libavutil/common.h"
 #include "libavutil/intreadwrite.h"
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 static int text2movsub(AVBSFContext *ctx, AVPacket *out)
 {
diff --git a/libavcodec/mp3_header_decompress_bsf.c b/libavcodec/mp3_header_decompress_bsf.c
index ab3d420300..158d96853e 100644
--- a/libavcodec/mp3_header_decompress_bsf.c
+++ b/libavcodec/mp3_header_decompress_bsf.c
@@ -21,7 +21,7 @@
 #include "libavutil/common.h"
 #include "libavutil/intreadwrite.h"
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "mpegaudiodecheader.h"
 #include "mpegaudiodata.h"
 
diff --git a/libavcodec/mpeg2_metadata_bsf.c b/libavcodec/mpeg2_metadata_bsf.c
index 3f371a028d..8c6dad9625 100644
--- a/libavcodec/mpeg2_metadata_bsf.c
+++ b/libavcodec/mpeg2_metadata_bsf.c
@@ -20,7 +20,7 @@
 #include "libavutil/common.h"
 #include "libavutil/opt.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_mpeg2.h"
 #include "mpeg12.h"
diff --git a/libavcodec/mpeg4_unpack_bframes_bsf.c b/libavcodec/mpeg4_unpack_bframes_bsf.c
index 1500d2135d..6934cce73a 100644
--- a/libavcodec/mpeg4_unpack_bframes_bsf.c
+++ b/libavcodec/mpeg4_unpack_bframes_bsf.c
@@ -20,7 +20,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "internal.h"
 #include "mpeg4video.h"
 
diff --git a/libavcodec/noise_bsf.c b/libavcodec/noise_bsf.c
index 721fd217ec..69bd87f3f3 100644
--- a/libavcodec/noise_bsf.c
+++ b/libavcodec/noise_bsf.c
@@ -22,7 +22,7 @@
 #include <string.h>
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 #include "libavutil/log.h"
 #include "libavutil/mem.h"
diff --git a/libavcodec/null_bsf.c b/libavcodec/null_bsf.c
index 24d26dfb1a..052355b6e6 100644
--- a/libavcodec/null_bsf.c
+++ b/libavcodec/null_bsf.c
@@ -22,7 +22,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 static int null_filter(AVBSFContext *ctx, AVPacket *pkt)
 {
diff --git a/libavcodec/prores_metadata_bsf.c b/libavcodec/prores_metadata_bsf.c
index 0510d3520a..239f5c3cfa 100644
--- a/libavcodec/prores_metadata_bsf.c
+++ b/libavcodec/prores_metadata_bsf.c
@@ -28,7 +28,7 @@
 #include "libavutil/common.h"
 #include "libavutil/intreadwrite.h"
 #include "libavutil/opt.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 typedef struct ProresMetadataContext {
     const AVClass *class;
diff --git a/libavcodec/remove_extradata_bsf.c b/libavcodec/remove_extradata_bsf.c
index b762079e05..7ea12d260a 100644
--- a/libavcodec/remove_extradata_bsf.c
+++ b/libavcodec/remove_extradata_bsf.c
@@ -22,7 +22,7 @@
 #include "libavutil/opt.h"
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 
 enum RemoveFreq {
     REMOVE_FREQ_KEYFRAME,
diff --git a/libavcodec/trace_headers_bsf.c b/libavcodec/trace_headers_bsf.c
index 3ec78fe822..ffd4e5465b 100644
--- a/libavcodec/trace_headers_bsf.c
+++ b/libavcodec/trace_headers_bsf.c
@@ -22,7 +22,7 @@
 #include "libavutil/common.h"
 #include "libavutil/log.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 
 
diff --git a/libavcodec/truehd_core_bsf.c b/libavcodec/truehd_core_bsf.c
index dbd05b34ca..59e5b0035c 100644
--- a/libavcodec/truehd_core_bsf.c
+++ b/libavcodec/truehd_core_bsf.c
@@ -19,7 +19,7 @@
  */
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "get_bits.h"
 #include "mlp_parse.h"
 #include "mlp.h"
diff --git a/libavcodec/vp9_metadata_bsf.c b/libavcodec/vp9_metadata_bsf.c
index 52e962b1c0..974a5fc6dd 100644
--- a/libavcodec/vp9_metadata_bsf.c
+++ b/libavcodec/vp9_metadata_bsf.c
@@ -20,7 +20,7 @@
 #include "libavutil/common.h"
 #include "libavutil/opt.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "cbs.h"
 #include "cbs_vp9.h"
 
diff --git a/libavcodec/vp9_raw_reorder_bsf.c b/libavcodec/vp9_raw_reorder_bsf.c
index e55a358457..531cd99003 100644
--- a/libavcodec/vp9_raw_reorder_bsf.c
+++ b/libavcodec/vp9_raw_reorder_bsf.c
@@ -22,7 +22,7 @@
 #include "libavutil/mem.h"
 #include "libavutil/opt.h"
 
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "get_bits.h"
 #include "put_bits.h"
 
diff --git a/libavcodec/vp9_superframe_bsf.c b/libavcodec/vp9_superframe_bsf.c
index b79911bb2c..2584604817 100644
--- a/libavcodec/vp9_superframe_bsf.c
+++ b/libavcodec/vp9_superframe_bsf.c
@@ -21,7 +21,7 @@
 
 #include "libavutil/avassert.h"
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "get_bits.h"
 
 #define MAX_CACHE 8
diff --git a/libavcodec/vp9_superframe_split_bsf.c b/libavcodec/vp9_superframe_split_bsf.c
index 13e85c3ca4..00f40aa96e 100644
--- a/libavcodec/vp9_superframe_split_bsf.c
+++ b/libavcodec/vp9_superframe_split_bsf.c
@@ -25,7 +25,7 @@
 #include <stddef.h>
 
 #include "avcodec.h"
-#include "bsf.h"
+#include "bsf_internal.h"
 #include "bytestream.h"
 #include "get_bits.h"
 